from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int

Gtftk_Mk_Matrix_V0_1_0 = CommandToolBuilder(tool="gtftk_mk_matrix", base_command=["gtftk", "mk_matrix"], inputs=[ToolInput(tag="in_input_file", input_type=Boolean(optional=True), prefix="--inputfile", doc=InputDocumentation(doc="A GTF file or bed file. A GTF if <stdin>. (default: <stdin>)")), ToolInput(tag="in_bigwig_list", input_type=Boolean(optional=True), prefix="--bigwiglist", doc=InputDocumentation(doc="A list of Bigwig files (last argument). (default: None)")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--outputfile", doc=InputDocumentation(doc="Output file name (.zip extension will be added). (default: <stdout>)")), ToolInput(tag="in_labels", input_type=Boolean(optional=True), prefix="--labels", doc=InputDocumentation(doc="Bigwig labels (i.e short name version for plotting). (default: None)")), ToolInput(tag="in_ft_type", input_type=Boolean(optional=True), prefix="--ft-type", doc=InputDocumentation(doc="If input is a GTF, the region to analyse. (default: promoter)")), ToolInput(tag="in_pseudo_count", input_type=Boolean(optional=True), prefix="--pseudo-count", doc=InputDocumentation(doc="Pseudo-count to add to all values. (default: 0)")), ToolInput(tag="in_upstream", input_type=Boolean(optional=True), prefix="--upstream", doc=InputDocumentation(doc="Extend the region of interest in 5' by a given value. (default: 1000)")), ToolInput(tag="in_downstream", input_type=Boolean(optional=True), prefix="--downstream", doc=InputDocumentation(doc="Extend the region of interest in 3' by a given value. (default: 1000)")), ToolInput(tag="in_chrom_info", input_type=Boolean(optional=True), prefix="--chrom-info", doc=InputDocumentation(doc="Tabulated file (chr as column 1, sizes as column 2.) (default: None)")), ToolInput(tag="in_bin_nb", input_type=Boolean(optional=True), prefix="--bin-nb", doc=InputDocumentation(doc="Split the region into w bins. (default: 100)")), ToolInput(tag="in_nb_proc", input_type=Boolean(optional=True), prefix="--nb-proc", doc=InputDocumentation(doc="Use this many threads to compute coverage. (default: 1)")), ToolInput(tag="in_bin_around_frac", input_type=Boolean(optional=True), prefix="--bin-around-frac", doc=InputDocumentation(doc="Fraction of bins used in 5' and 3' regions. (default: 0.1)")), ToolInput(tag="in_zero_to_na", input_type=Boolean(optional=True), prefix="--zero-to-na", doc=InputDocumentation(doc="Use NA not zero when region is undefined in bigwig. (default: False)")), ToolInput(tag="in_no_stranded", input_type=Boolean(optional=True), prefix="--no-stranded", doc=InputDocumentation(doc="The bins should not be oriented relative to strand. (default: False)")), ToolInput(tag="in_verbosity", input_type=Boolean(optional=True), prefix="--verbosity", doc=InputDocumentation(doc="Set output verbosity ([0-3]). (default: 0)")), ToolInput(tag="in_no_date", input_type=File(optional=True), prefix="--no-date", doc=InputDocumentation(doc="Do not add date to output file names. (default: False)")), ToolInput(tag="in_add_chr", input_type=Boolean(optional=True), prefix="--add-chr", doc=InputDocumentation(doc="Add 'chr' to chromosome names before printing output. (default: False)")), ToolInput(tag="in_tmp_dir", input_type=Boolean(optional=True), prefix="--tmp-dir", doc=InputDocumentation(doc="Keep all temporary files into this folder. (default: None)")), ToolInput(tag="in_keep_all", input_type=Boolean(optional=True), prefix="--keep-all", doc=InputDocumentation(doc="Try to keep all temporary files even if process does not terminate normally. (default: False)")), ToolInput(tag="in_logger_file", input_type=Boolean(optional=True), prefix="--logger-file", doc=InputDocumentation(doc="Stores the arguments passed to the command into a file. (default: None)")), ToolInput(tag="in_write_message_to_file", input_type=Boolean(optional=True), prefix="--write-message-to-file", doc=InputDocumentation(doc="Store all message into a file. (default: None)")), ToolInput(tag="in_arguments", input_type=Int(), position=0, doc=InputDocumentation(doc="Arguments:"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="Output file name (.zip extension will be added). (default: <stdout>)")), ToolOutput(tag="out_no_date", output_type=File(optional=True), selector=InputSelector(input_to_select="in_no_date", type_hint=File()), doc=OutputDocumentation(doc="Do not add date to output file names. (default: False)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Gtftk_Mk_Matrix_V0_1_0().translate("wdl", allow_empty_container=True)

